/********************************************************************************

PROJECT:		CS 298 Project

FILE:			inputview.cpp

PURPOSE:		Displays input image to be aged.

COMPILER:		Visual C++ .NET 2003

PROGRAMMER:		Wallun Chan

START DATE:		9/1/05	

********************************************************************************/

#include "stdafx.h"
#include "PCA_Reconstructor.h"
#include "PCA_ReconstructorDoc.h"
#include "inputview.h"
#include "outputview.h"
#include "controlview.h"

IMPLEMENT_DYNCREATE(CInputView, CSelectView)

CInputView::CInputView() : reconstructEnable(FALSE)
{
}

CInputView::~CInputView()
{
}

BEGIN_MESSAGE_MAP(CInputView, CSelectView)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_RECONSTRUCT_CONTEXT, OnReconstructContext)
	ON_COMMAND(ID_RESET_INPUT_CONTEXT, OnResetInputContext)
END_MESSAGE_MAP()

void CInputView::OnInitialUpdate()
{
	CSelectView::OnInitialUpdate();
	param = &(((CPCA_ReconstructorDoc*)GetDocument())->iParam);
}

void CInputView::OnContextMenu(CWnd* pWnd, CPoint pos)
{
	CPCA_ReconstructorDoc* doc = (CPCA_ReconstructorDoc*)GetDocument();
	if (doc->iImage.IsEmpty())
		return;
	CMenu tmp;
	tmp.LoadMenu(IDR_MENU_CONTEXT2);
	CMenu* popUp = tmp.GetSubMenu(0);
	popUp->TrackPopupMenu(0, pos.x, pos.y, this);
}

BOOL CInputView::checkPoint(CPoint pos)
{
	return boundsCheck(((CPCA_ReconstructorDoc*)GetDocument())->iImage, pos);
}

void CInputView::OnReconstructContext()
{
	CPCA_ReconstructorDoc* doc = (CPCA_ReconstructorDoc*)GetDocument();
	CControlView* view = (CControlView*)doc->getView(RUNTIME_CLASS(CControlView));
	((CControlView*)view)->reconstruct();
}

void CInputView::OnResetInputContext()
{
	CPCA_ReconstructorDoc* doc = (CPCA_ReconstructorDoc*)GetDocument();
	CControlView* cView = (CControlView*)doc->getView(RUNTIME_CLASS(CControlView));
	param->reset();
	updateInputParams(doc->iImage);
	double sigma = cView->edgeDetectDialog->getDoubleParam();
	int threshold = cView->edgeDetectDialog->getIntParam();
	if (cView->isInputChecked())
		displayEdges(doc->iImage, sigma, &threshold);
	else
		displayRotate(doc->iImage);
	cView->resetInputAngle();
	CView* oView = doc->getView(RUNTIME_CLASS(COutputView));
	((COutputView*)oView)->clear();
}