#include "stdafx.h"
#include "PCA_Reconstructor.h"
#include "MainFrm.h"
#include "ControlView.h"
#include "InputView.h"
#include "OutputView.h"
#include "trainingview.h"
#include "constants.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;
	}
	if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(
		indicators, sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;
	}
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	SetTitle(APP_TITLE);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext *pContext)
{
	if (!splitLR.CreateStatic(this, 1, 2))
		return FALSE;
	if (!splitLR.CreateView(0, 0, RUNTIME_CLASS(CControlView), CSize(), pContext))
		return FALSE;
	if (!splitUD.CreateStatic(&splitLR, 2, 1, 
		WS_CHILD | WS_VISIBLE, splitLR.IdFromRowCol(0, 1)))
		return FALSE;
	if (!splitUD.CreateView(0, 0, RUNTIME_CLASS(CTrainingView), CSize(), pContext))
		return FALSE;
	if (!splitViews.CreateStatic(&splitUD, 1, 2, 
		WS_CHILD | WS_VISIBLE, splitUD.IdFromRowCol(1, 0)))
		return FALSE;
	if (!splitViews.CreateView(0, 0, RUNTIME_CLASS(CInputView), CSize(), pContext))
		return FALSE;
	if (!splitViews.CreateView(0, 1, RUNTIME_CLASS(COutputView), CSize(), pContext))
		return FALSE;
	int width = GetSystemMetrics(SM_CXSCREEN);
	int height = GetSystemMetrics(SM_CYSCREEN);
	int base = width / 4;
	int remaining = width - base;
	splitLR.SetColumnInfo(0, base, 0);
	splitUD.SetRowInfo(0, width / 3, 0);
	splitViews.SetColumnInfo(0, remaining / 2, 0);
	return TRUE;
}

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif