/********************************************************************************

PROJECT:		CS 298 Project

FILE:			OutputView.cpp

PURPOSE:		Displays aged image.

COMPILER:		Visual C++ .NET 2003

PROGRAMMER:		Wallun Chan

START DATE:		9/1/05		

********************************************************************************/

#include "stdafx.h"
#include "PCA_Reconstructor.h"
#include "PCA_ReconstructorDoc.h"
#include "OutputView.h"
#include "winutil.h"

IMPLEMENT_DYNCREATE(COutputView, CImageView)

COutputView::COutputView()
{
}

COutputView::~COutputView()
{
}

BEGIN_MESSAGE_MAP(COutputView, CImageView)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_IMAGE_SAVE_CONTEXT, OnImageSaveContext)
END_MESSAGE_MAP()

void COutputView::OnImageSaveContext()
{
	CPCA_ReconstructorDoc* doc = (CPCA_ReconstructorDoc*)GetDocument();
	CFileDialog dialog(0, DEFAULT_EXT, imageName + AGED_EXT, 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, FILTER);
	if (dialog.DoModal() == IDCANCEL)
		return;
	if (!image.save(dialog.GetPathName()))
		MessageBox(IMAGE_SAVE_ERROR_MSG, IMAGE_SAVE_ERROR_CAP);
}

void COutputView::OnContextMenu(CWnd* pWnd, CPoint pos)
{
	if (image.isNull())
		return;
	CPCA_ReconstructorDoc* doc = (CPCA_ReconstructorDoc*)GetDocument();
	CMenu tmp;
	tmp.LoadMenu(IDR_MENU_CONTEXT3);
	CMenu* popUp = tmp.GetSubMenu(0);
	popUp->TrackPopupMenu(0, pos.x, pos.y, this);
}

void COutputView::setBorderText(const CString& text, const CString& name)
{
	borderText = text + name;
}