#include "stdafx.h"
#include "PCA_Reconstructor.h"
#include "PCATruncationDialog.h"
#include "constants.h"


// CPCATruncationDialog dialog

IMPLEMENT_DYNAMIC(CPCATruncationDialog, CDialogBox)
CPCATruncationDialog::CPCATruncationDialog(CWnd* pParent)
	: CDialogBox(CPCATruncationDialog::IDD, pParent)
{
	truncPercStr.Format("%d", DEFAULT_TRUNC_PERC);
}

CPCATruncationDialog::~CPCATruncationDialog()
{
}

void CPCATruncationDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialogBox::DoDataExchange(pDX);
}

int CPCATruncationDialog::getTruncPercentage() const
{
	return atoi(truncPercStr);
}


BEGIN_MESSAGE_MAP(CPCATruncationDialog, CDialogBox)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_PCA_OK_BUTTON, OnBnClickedPcaOkButton)
	ON_BN_CLICKED(IDC_PCA_CANCEL_BUTTON, OnBnClickedPcaCancelButton)
END_MESSAGE_MAP()


// CPCATruncationDialog message handlers

void CPCATruncationDialog::OnShowWindow(BOOL bShow, UINT nStatus)
{
	SetDlgItemText(IDC_PCA_EDIT, truncPercStr);
}

void CPCATruncationDialog::OnBnClickedPcaOkButton()
{
	GetDlgItemText(IDC_PCA_EDIT, truncPercStr);
	ShowWindow(SW_HIDE);
}

void CPCATruncationDialog::OnBnClickedPcaCancelButton()
{
	ShowWindow(SW_HIDE);
}
