/********************************************************************************

PROJECT:		CS 298 Project

FILE:			ParamDialog.cpp

PURPOSE:		Input dialog box for edge detection parameters.

COMPILER:		Visual C++ .NET 2003

PROGRAMMER:		Wallun Chan

START DATE:		9/1/05	

********************************************************************************/

#include "stdafx.h"
#include "PCA_Reconstructor.h"
#include "ParamDialog.h"
#include "ControlView.h"
#include "constants.h"

IMPLEMENT_DYNAMIC(CParamDialog, CDialogBox)

CParamDialog::CParamDialog(CWnd* pParent) 
	: CDialogBox(CParamDialog::IDD, pParent), 
	callBack(FALSE)
{
}

CParamDialog::CParamDialog(CWnd* pParent, 
	double parameter1, int parameter2,
	const CString& str1, const CString& str2,
	const CString& titleStr, int callBackFlag)
	: CDialogBox(CParamDialog::IDD, pParent), 
	text1(str1), text2(str2), title(titleStr), 
	callBack(callBackFlag)
{	
	param1.Format("%f", parameter1);
	param2.Format("%d", parameter2);
}

CParamDialog::~CParamDialog()
{
}

void CParamDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialogBox::DoDataExchange(pDX);
}

BOOL CParamDialog::OnInitDialog()
{
	BOOL flag = CDialogBox::OnInitDialog();
	SetDlgItemText(IDC_PARAM_TEXT1_STATIC, text1);
	SetDlgItemText(IDC_PARAM_TEXT2_STATIC, text2);
	SetWindowText(title);
	update();
	return flag;
}

void CParamDialog::update(BOOL flag)
{
	if (flag)
	{	SetDlgItemText(IDC_PARAM_EDIT1, param1);
		SetDlgItemText(IDC_PARAM_EDIT2, param2);
	}
	else
	{	GetDlgItemText(IDC_PARAM_EDIT1, param1);
		GetDlgItemText(IDC_PARAM_EDIT2, param2);
	}
}


BEGIN_MESSAGE_MAP(CParamDialog, CDialogBox)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_PARAM_OK_BUTTON, OnBnClickedParamOkButton)
	ON_BN_CLICKED(IDC_PARAM_CANCEL_BUTTON, OnBnClickedParamCancelButton)
END_MESSAGE_MAP()


// CParamDialog message handlers

void CParamDialog::OnShowWindow(BOOL bShow, UINT nStatus)
{
	update();
}

void CParamDialog::OnBnClickedParamOkButton()
{
	if (callBack)
		((CControlView*)parent)->setExtractedFlag(FALSE);
	update(FALSE);
	ShowWindow(SW_HIDE);
}

void CParamDialog::OnBnClickedParamCancelButton()
{
	ShowWindow(SW_HIDE);
}

double CParamDialog::getDoubleParam() const
{
	return atof(param1);
}

int CParamDialog::getIntParam() const
{
	return atoi(param2);
}