#pragma once

#include "dialogbox.h"
#include "constants.h"

// CParamDialog dialog

class CParamDialog : public CDialogBox
{
	DECLARE_DYNAMIC(CParamDialog)

public:
	CParamDialog(CWnd* pParent = 0);
	CParamDialog(CWnd* pParent,
		double sigma, int threshold,
		const CString& = EMPTY_STR, 
		const CString& = EMPTY_STR,
		const CString& = EMPTY_STR,
		int callBackFlag = FALSE);   // standard constructor
	virtual ~CParamDialog();
	double getDoubleParam() const;
	int getIntParam() const;

// Dialog Data
	enum { IDD = IDD_PARAM_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog(); 
	void update(BOOL = TRUE);
	DECLARE_MESSAGE_MAP()

protected:
	CString param1;
	CString param2;
	CString text1;
	CString text2;
	CString title;
	BOOL callBack;

public:
	afx_msg void OnBnClickedParamOkButton();
	afx_msg void OnBnClickedParamCancelButton();
	afx_msg void OnShowWindow(BOOL, UINT);
};
