#include "stdafx.h"
#include "PCA_Reconstructor.h"
#include "controlview.h"
#include "ProgressDialog.h"
#include "constants.h"

HWND CProgressDialog::wHnd = 0;

IMPLEMENT_DYNAMIC(CProgressDialog, CDialogBox)

CProgressDialog::CProgressDialog(CWnd* pParent)
	: CDialogBox(CProgressDialog::IDD, pParent)
{
}

CProgressDialog::~CProgressDialog()
{
}

void CProgressDialog::OnShowWindow(BOOL bShow, UINT nStatus)
{
	SendDlgItemMessage(IDC_PROG_BAR, PBM_SETPOS, 0, 0);
}

void CProgressDialog::setProgress(int progress)
{
	::SendDlgItemMessage(m_hWnd, IDC_PROG_BAR, PBM_SETPOS, progress, 0);
}

void CProgressDialog::setText(int id, const CString& msg)
{
	SetDlgItemText(id, msg);
}

void CProgressDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialogBox::DoDataExchange(pDX);
}

BOOL CProgressDialog::OnInitDialog()
{
	wHnd = m_hWnd;
	return CDialogBox::OnInitDialog();
}


BEGIN_MESSAGE_MAP(CProgressDialog, CDialogBox)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_PROGRESS_STOP_BUTTON, OnBnClickedProgressStopButton)
END_MESSAGE_MAP()


// CProgressDialog message handlers

void CProgressDialog::OnBnClickedProgressStopButton()
{
	((CControlView*)parent)->setStopFlag(TRUE);
}