#pragma once

#include "imageview.h"
#include "datastructures.h"

class CSelectView : public CImageView
{
	DECLARE_DYNCREATE(CSelectView)

protected:
	CSelectView();
	virtual ~CSelectView();
	CImageMatrix refImage;
	CPoint startPoint;
	CPoint endPoint;
	CFaceParams* param;
	BOOL dragging;

public:
	virtual void display(const CString&);
	virtual void display(const CImageMatrix&);
	virtual void clear();
	void rotate(const CString&, double);
	void displayRotate(const CString&);
	void displayEdges(const CString&, double, int*, 
		COLORREF = YELLOW);
	void updateTrainingParams(const CString&);
	void updateInputParams(const CString&);

public:
	virtual void OnDraw(CDC*);
	virtual void OnInitialUpdate();

protected:
	virtual BOOL checkPoint(CPoint);
	BOOL boundsCheck(const CString&, CPoint);

protected:
	afx_msg void OnLButtonDown(UINT, CPoint);
	afx_msg void OnMouseMove(UINT, CPoint);
	afx_msg void OnLButtonUp(UINT, CPoint);

	DECLARE_MESSAGE_MAP()
};


