#ifndef _DATA_STRUCTURES_H_
#define _DATA_STRUCTURES_H_

#include "matrx.h"
#include "constants.h"

class EigenUtil;

struct CFaceParams
{
	CFaceParams();
	BOOL allSelected() const;
	BOOL noneSelected() const;
	void reset();
	void operator=(const CFaceParams&);
	CRect rect[FEATURE_NUM];
	int select[FEATURE_NUM];
	double angle;
};

struct CData
{		
	CData() : width(0), height(0) {}
	CFaceParams param;
	CString file;
	int width, height;	
};

struct CTrainingData : public CObject
{
	CTrainingData();
	~CTrainingData();
	CData* uData;
	CData* aData;
};

class CFaceMap
{
	friend class CEigenUtil;

public:
	CFaceMap();
	virtual ~CFaceMap();
	void addDataMapping(const CString&, const CString&, const CString&);
	void extractFeatureData(double, int*, int*, FuncPtr);
	void clearAll();
	void setFaceAngle(const CString&, double&, BOOL = FALSE);
	BOOL isFeatureSelected(const CString&, Feature) const;
	void selectFeature(const CString&, Feature, BOOL = TRUE);
	void setFeatureRect(const CString&, CRect&, Feature, BOOL = FALSE);
	int getWidth(const CString&) const;
	int getHeight(const CString&) const;
	double getAngle(const CString&) const;
	int getSize() const;
	BOOL isPathValid(const CString&) const;

private:
	CMapStringToPtr dataMap;
	CStringArray strArr;
	CData* getData(const CString&) const;
	BOOL split(const CString&, CString&, CString&) const;
};

#endif