/***************************************************************************

PROJECT:		CS 298 Project

FILE:			featurelocate.h

PURPOSE:		Finds boundary boxes around face features.

COMPILER:		Visual C++ .NET 2003

PROGRAMMER:		Wallun Chan

START DATE:		9/1/05

REMARKS:		Invokes face detection library taken from
				http://vasc.ri.cmu.edu/NNFaceDetector.

***************************************************************************/ 

#ifndef _FACE_PROCESSOR_H_
#define _FACE_PROCESSOR_H_

#include "imagematrix.h"
#include "datastructures.h"

extern "C"
{
#include "detect.h"
}

class CFeatureLocate
{
public:
	CFeatureLocate();
	~CFeatureLocate();
	void setImage(CImageMatrix*);
	BOOL setData(CData*, double, int*);

private:
	int width, height;
	CImageMatrix* imageMatrix;
	CFeatureLocate(const CFeatureLocate&);
	operator=(const CFeatureLocate&);
	FaceEyeLocation* findFace();
	void boundRegion(CRect*, const CRect&, int);
	CRect centerBox(const CImageMatrix&, const CRect&, double, int*);
	CPoint rotatePoint(int, int, double, int, int);
};

#endif