/********************************************************************************

PROJECT:		CS 298 Project

FILE:			polygontester.cpp

PURPOSE:		Tests whether point is in an arbitrary polygon.

COMPILER:		Visual C++ .NET 2003

PROGRAMMER:		Wallun Chan

START DATE:		9/1/05

********************************************************************************/

#include "stdafx.h"
#include "polygontester.h"

CPolygonTester::CPolygonTester(VecIntPr& h) : hull(h)
{
}

bool CPolygonTester::onSegment(const DPr& pi, const DPr& pj, const DPr& pk)
{
	double cross = (pk.first - pi.first) * (pj.second - pi.second) -
		(pj.first - pi.first) * (pk.second - pi.second);
	if (cross > TOLERANCE || cross < -TOLERANCE)
		return false;
	if (((pk.first > min(pi.first, pj.first) - TOLERANCE) &&
		(pk.first < max(pi.first, pj.first) + TOLERANCE)) &&
		((pk.second > min(pi.second, pj.second) - TOLERANCE) &&
		(pk.second < max(pi.second, pj.second) + TOLERANCE)))
		return true;
	return false;
}

bool CPolygonTester::isPointInPolygon(double testPtX, double testPtY)
{
	int intersections = 0;
	int n = (int)hull.size();
	for (int i = 0; i < n; i++)
	{	int j = (i + n - 1) % n;
		DPr pt1(hull[i].first - testPtX, hull[i].second - testPtY);
		DPr pt2(hull[j].first - testPtX, hull[j].second - testPtY);
		if (pt1.first < TOLERANCE && pt1.first > -TOLERANCE &&
			pt1.second < TOLERANCE && pt1.second > -TOLERANCE)
			return true;
		if (onSegment(pt1, pt2, DPr()))
			return true;
		if (((pt1.second > 0.0) && (pt2.second <= 0.0)) ||
			((pt2.second > 0.0) && (pt1.second <= 0.0)))
		{	double xIntercept = ((pt1.first - pt2.first) * 
					pt1.second - (pt1.second - pt2.second) * 
					pt1.first) / (pt2.second - pt1.second);
			if (xIntercept > 0.0)
				intersections++;
		}
	}
	return (intersections % 2) == 1 ? true : false;
}
