#include "stdafx.h"
#include "PCA_Reconstructor.h"
#include "PCA_ReconstructorDoc.h"
#include "trainingview.h"
#include "controlview.h"

IMPLEMENT_DYNCREATE(CTrainingView, CSelectView)

CTrainingView::CTrainingView()
{
}

CTrainingView::~CTrainingView()
{
}

BEGIN_MESSAGE_MAP(CTrainingView, CSelectView)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_UPDATE_CONTEXT, OnUpdateContext)
	ON_COMMAND(ID_RESET_CONTEXT, OnResetContext)
END_MESSAGE_MAP()

void CTrainingView::OnInitialUpdate()
{
	CSelectView::OnInitialUpdate();
	param = &(((CPCA_ReconstructorDoc*)GetDocument())->tParam);
}

BOOL CTrainingView::checkPoint(CPoint pos)
{
	return boundsCheck(((CPCA_ReconstructorDoc*)GetDocument())->dImage, pos);
}

void CTrainingView::OnContextMenu(CWnd* pWnd, CPoint pos)
{
	CPCA_ReconstructorDoc* doc = (CPCA_ReconstructorDoc*)GetDocument();
	if (doc->dImage.IsEmpty())
		return;
	CMenu tmp;
	tmp.LoadMenu(IDR_MENU_CONTEXT1);
	CMenu* popUp = tmp.GetSubMenu(0);
	popUp->TrackPopupMenu(0, pos.x, pos.y, this);
}

void CTrainingView::OnUpdateContext()
{
	CPCA_ReconstructorDoc* doc = (CPCA_ReconstructorDoc*)GetDocument();
	CControlView* view = (CControlView*)doc->getView(RUNTIME_CLASS(CControlView));
	if (view->isRunning)
	{	AfxMessageBox(RUNNING_MSG);
		return;
	}
	doc->imageMap.setFaceAngle(doc->dImage, param->angle, TRUE);
	for (int i = 0; i < FEATURE_NUM; i++)
	{	if (param->select[i])
		{	doc->imageMap.setFeatureRect(doc->dImage, 
				param->rect[i], (Feature)i, TRUE);
			doc->imageMap.selectFeature(doc->dImage, (Feature)i);
		}
	}
	view->isTrained = FALSE;
	MessageBox(UPDATE_FEATURE_MSG, UPDATE_FEATURE_CAPTION);
}

void CTrainingView::OnResetContext()
{
	CPCA_ReconstructorDoc* doc = (CPCA_ReconstructorDoc*)GetDocument();
	CControlView* view = (CControlView*)doc->getView(RUNTIME_CLASS(CControlView));
	((CControlView*)view)->resetTrainingAngle();
	updateTrainingParams(doc->dImage);
	double sigma = view->edgeDetectDialog->getDoubleParam();
	int threshold = view->edgeDetectDialog->getIntParam();
	if (view->isTrainingChecked())
		displayEdges(doc->dImage, sigma, &threshold);
	else
		displayRotate(doc->dImage);
}
